/**
  *  \file client/cm-distance.h
  *  \brief Starchart mode: Distance
  *
  *  (c) 2001-2010 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_CM_DISTANCE_H
#define PCC_V2_CLIENT_CM_DISTANCE_H

#include "client/chartmode.h"
#include "game/coord.h"

/** Distance mode. Display distance between two points on map. */
class WDistanceChartMode : public WSimpleChartMode {
    GPoint origin;
    int    ship_id;

 public:
    WDistanceChartMode(GPoint origin, int ship_id);
    ~WDistanceChartMode();

    bool handleEvent(const UIEvent& event, GChartLocation& loc);
    void drawOverlays(GfxCanvas& can, GChartLocation& loc);
    void drawCursor(GfxCanvas& can, GChartLocation& loc);
    void onMove(GChartLocation& loc);
};

#endif
